{=====================================================================}
{ This file is part of GenerateSecret                                 }
{ copyright 2002 by Thomas Mueller                                    }
{                                                                     }
{ You may use it freely at your own risk in any kind of environment.  }
{                                                                     }
{=====================================================================}
unit w_GenerateSecret;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Variants,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  StdCtrls;

type
  Tf_GenerateSecret = class(TForm)
    l_Username: TLabel;
    ed_Username: TEdit;
    l_Password: TLabel;
    ed_Password: TEdit;
    b_Generate: TButton;
    l_Secret: TLabel;
    ed_Secret: TEdit;
    l_Description: TLabel;
    b_Exit: TButton;
    b_About: TButton;
    procedure b_GenerateClick(Sender: TObject);
    procedure b_ExitClick(Sender: TObject);
    procedure b_AboutClick(Sender: TObject);
  private
    { Private declarations }
  public
    constructor Create(_Owner: TComponent); override;
  end;

var
  f_GenerateSecret: Tf_GenerateSecret;

implementation

{$R *.dfm}

uses
  w_About,
  Base64;

{ Tf_GenerateSecret }

constructor Tf_GenerateSecret.Create(_Owner: TComponent);
begin
  inherited;
  l_Description.Caption := 'This program generates the secret for opt-dyndns.'#13#10#13#10 +
    'Dieses Programm erzeugt das "Secret" fr opt-dyndns.';
end;

procedure Tf_GenerateSecret.b_GenerateClick(Sender: TObject);
var
  Buffer: string;
  InText: string;
  Len: integer;
begin
  InText := ed_Username.Text + ':' + ed_Password.Text;
  SetLength(Buffer, 1024);
  Len := Length(Buffer);
  TBase64.Encode(PChar(InText), Length(InText), PChar(Buffer), Len, true);
  SetLength(Buffer, Len);
  ed_Secret.Text := Buffer;
end;

procedure Tf_GenerateSecret.b_ExitClick(Sender: TObject);
begin
  Close;
end;

procedure Tf_GenerateSecret.b_AboutClick(Sender: TObject);
begin
  with tf_About.Create(self) do
    begin
      ShowModal;
      Free;
    end;
end;

end.

